Subject: [RFC PATCH 0/3] arm64: relocatable kernel proof of concept

From: [email-masked] (Mark Rutland)
Date: Tue, 17 Mar 2015 16:20:31 +0000

> > Hmm. I'd be rather worried about the fixup step; I suspect that'll be
> > fragile and rarely tested. Perhaps we could verify them at boot time?
> 
> It would essentially be __relocate_kernel() but executed at build time against vmlinux with a reloc offset of #0

Sure, the logic is simple enough.

What I'm worried about is something changing in the build system
somewhere and we accidentally miss the fixup somehow in some cases,
we accidentally apply the fixup to the wrong field, or things like that.

At that stage there's very little sanity checking that we can do a la
BUILD_BUG_ON, ASSERT, etc.

Which isn't to say that we can't do that, just that I feel a little
uneasy about it.

Mark.